<?php

$padd_themename = 'Maasahan';
$padd_shortname = 'maasahan';
$padd_prefix = 'padd';

if (function_exists('register_sidebar')) {
	register_sidebar(array(
			'name' => 'Side Bar 1',
			'before_widget' => '<div class="box box-%2$s">',
			'after_widget' => '</div></div>',
			'before_title' => '<h2>',
			'after_title' => '</h2><div class="interior">',
		)
	);
	register_sidebar(array(
			'name' => 'Side Bar 2',
			'before_widget' => '<div class="box box-%2$s">',
			'after_widget' => '</div></div>',
			'before_title' => '<h2>',
			'after_title' => '</h2><div class="interior">',
		)
	);
}

require get_theme_root() . '/' . $padd_shortname . '/functions/option.php';
require get_theme_root() . '/' . $padd_shortname . '/functions/advertisement.php';

$options_general = array(
	new Option(
		$padd_prefix . '_primary_author',
		'Главный автор',
		'Укажите главного автора вашего сайта. Для этого, введите имя зарегистрированного пользователя в это поле. Если поле пустое, по-умолчанию главным автором будет назначен admin.',
		'textbox',
		'250'
	),
	new Option(
		$padd_prefix . '_twitter_username',
		'Имя в Twitter',
		'Ваше имя <a href="http://twitter.com">Twitter</a>. Вы можете оставить поле пустым, если у вас нет аккаунта Twitter, но мы рекомендуем <a href="http://twitter.com/signup">создать аккаунт.',
		'textbox',
		'250'
	),
	new Option(
		$padd_prefix . '_feedburner_id',
		'ID Feed Burner',
		'',
		'textbox',
		'250'
	),
);

$options_gallery = array(
	new Option(
		$padd_prefix . '_featured_slug',
		'Короткая ссылка рубрики',
		'Короткая ссылка рубрики, записи из которой должны использоваться в показе слайдов.',
		'textbox',
		'250'
	),
	new Option(
		$padd_prefix . '_featured_count',
		'Количество записей для показа',
		'Количество записей для показа в слайдах. Значение должно быть равно как миниум 2, иначе слайды не будут работать.',
		'textbox',
		'250'
	)
);

$options_google = array(
	new Option(
		$padd_prefix . '_ad_468',
		'Баннер Google Adsense (468x60)',
		'Этот баннер располагается перед записями блога, в результатах поиска и в рубриках.',
		'textarea'
	),
	new Option(
		$padd_prefix . '_ad_250',
		'Текстовая реклама Google Adsense (250x250)',
		'Этот рекламный блок располагается в правом нижнем углу бокового меню.',
		'textarea'
	),
);

$options_yourads = array(
	new Advertisement(
		$padd_prefix . '_banner',
		'Баннер (468x60) в шапке',
		'Этот баннер располагается в правом верхнем углу сайта возле заголовка.'
	),
	new Advertisement(
		$padd_prefix . '_sqbtn_1',
		'Рекламный квадрат 1 (125x125)',
		'Этот рекламный блок располагается в правом верхнем углу бокового меню.'
	),
	new Advertisement(
		$padd_prefix . '_sqbtn_2',
		'Square Ad 2 (125x125)',
		'Этот рекламный блок располагается в правом верхнем углу бокового меню.'
	),
	new Advertisement(
		$padd_prefix . '_sqbtn_3',
		'Рекламный квадрат 3 (125x125)',
		'Этот рекламный блок располагается в правом верхнем углу бокового меню.'
	),
	new Advertisement(
		$padd_prefix . '_sqbtn_4',
		'Рекламный квадрат 4 (125x125)',
		'Этот рекламный блок располагается в правом верхнем углу бокового меню.'
	),
);



function themefunction_add_admin() {
	global $padd_themename, $padd_shortname, $options_general, $options_gallery, $options_google, $options_yourads;
	
	if ( $_GET['page'] == basename(__FILE__) ) {
		if ( 'save' == $_REQUEST['action'] ) {

			foreach ($options_general as $opt) {
				update_option($opt->getKeyword(),$_REQUEST[$opt->getKeyword()]);
			}

			foreach ($options_gallery as $opt) {
				update_option($opt->getKeyword(),stripslashes($_REQUEST[$opt->getKeyword()]));
			}
			
			foreach ($options_google as $opt) {
				update_option($opt->getKeyword(),stripslashes($_REQUEST[$opt->getKeyword()]));
			}

			foreach ($options_yourads as $opt) {
				update_option($opt->getKeyword('img'),$_REQUEST[$opt->getKeyword('img')]);
				update_option($opt->getKeyword('web'),$_REQUEST[$opt->getKeyword('web')]);
			}

			header("Location: themes.php?page=functions.php&saved=true");
			die;
			
		} else if ( 'reset' == $_REQUEST['action'] ) {

			foreach ($options_general as $opt) {
				delete_option($opt->getKeyword());
			}

			foreach ($options_gallery as $opt) {
				delete_option($opt->getKeyword());
			}

			foreach ($options_google as $opt) {
				delete_option($opt->getKeyword());
			}

			foreach ($options_yourads as $opt) {
				delete_option($opt->getKeyword('img'));
				delete_option($opt->getKeyword('web'));
			}
			
			header("Location: themes.php?page=functions.php&reset=true");
			die;
		}
	}
	
	add_theme_page($padd_themename ." – Настройки", $padd_themename . " – Настройки", 'edit_themes', basename(__FILE__), 'themefunction_admin');
}

function themefunction_admin() {
    global $padd_themename, $padd_shortname, $options_general, $options_gallery, $options_google, $options_yourads;

    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$padd_themename.' настройки сохранены.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$padd_themename.' настройки сброшены.</strong></p></div>';
    
	require get_theme_root() . '/' . $padd_shortname . '/functions/userinterface.php';
}

add_action('admin_menu', 'themefunction_add_admin');



/********************************************/
/**** Functions used for hooking filters ****/
/********************************************/

function themefunction_alter_list_pages($string) {
	$string = str_replace(array("\n","\r","\t"),'', $string);

	$pattern = array('/<ul[^<>]*>/','/<\/ul[^<>]*>/');
	$replace = array('','');
	$string = preg_replace($pattern,$replace,$string);
	$pattern = array('/<a[^<>]*>/','/<\/a[^<>]*>/');
	$replace = array('$0<span><span>','</span></span>$0');
	$string = preg_replace($pattern,$replace,$string);

	$string = str_replace(array('</a><li','</li></li>'),array('</a></li><li','</li>'),$string);
	return $string;
}

function themefunction_alter_page_menu($string) {
	$string = themefunction_alter_list_pages($string);
	$pattern = array('/<div[^<>]*>/','/<\/div[^<>]*>/');
	$replace = array('','');
	$string = preg_replace($pattern,$replace,$string);
	return $string;
}

function themefunction_alter_links($string) {
	$pattern = array('/<a[^<>]*>/','/<\/a[^<>]*>/');
	$replace = array('$0<span>','</span>$0');
	$string = preg_replace($pattern,$replace,$string);
	return $string;
}


/***********************************************/
/**** Functions used for modifying the look ****/
/***********************************************/

function themefunction_page_menu() {
	add_filter('wp_page_menu','themefunction_alter_page_menu');
	wp_page_menu('show_home=1&title_li=');
	remove_filter('wp_page_menu','themefunction_alter_page_menu');
}

function themefunction_cleanup($str) {
	global $akpc, $post;
	$show = true;
	$show = apply_filters('akpc_display_popularity', $show, $post);
	if (is_feed() || is_admin_page() || get_post_meta($post->ID, 'hide_popularity', true) || !$show) {
		return $str;
	}
	return $str.'';
}

function themefunction_list_bookmarks() {
	$array = array();
	$array[] = 'category_before=';
	$array[] = 'category_after=';
	$array[] = 'categorize=0';
	$array[] = 'title_li=';
	wp_list_bookmarks(implode('&',$array)); 
}

function themefunction_recent_post() {
	echo '<ul>';
	wp_get_archives('type=postbypost&limit=5&format=custom&before=<li><span>&after=</span></li>');
	echo '</ul>';
}

function themefunction_recent_comments() {
	echo '<ul>';
	themefunction_format_get_comments();
	echo '</ul>';
}

function themefunction_get_categories($cat_id) {
	if ('' != get_the_category_by_ID($cat_id)) {
		echo '<li>';
		echo '<a href="' . get_category_link($cat_id) . '">' . get_the_category_by_ID($cat_id) . '</a>';
		if ('' != (get_category_children($cat_id))) {
			echo '<ul>';
			wp_list_categories('hide_empty=0&title_li=&child_of=' . $cat_id);
			echo '</ul>';
		}
	echo '</li>';
	}
}

function themefunction_get_recent_comments(
	$no_comments = 5,
	$show_pass_post = false,
	$title_length = 35, 	// shortens the title if it is longer than this number of chars
	$author_length = 15,	// shortens the author if it is longer than this number of chars
	$wordwrap_length = 35, // adds a blank if word is longer than this number of chars
	$comment_length = 80,
	$type = 'all', 	// Comments, trackbacks, or both?
	$format = '<li><a href="%permalink%" title="%title%">%title%</a><br />%excerpt% <cite>%author_name%</cite></li>',
	$date_format = 'd.m.y, G:i',
	$none_found = '<li>Отзывов нет.</li>',	// None found
	$type_text_pingback = 'Пинг от',
	$type_text_trackback = 'Трекбек от',
	$type_text_comment = 'Автор'

	) {

	//Language...
	$mwlang_anonymous = 'Гость'; // Anonymous
	$mwlang_authorurl_title_before = '&lsaquo;';
	$mwlang_authorurl_title_after = '&rsaquo;';

	global $wpdb;

	$request = "SELECT ID, comment_ID, comment_content, comment_author, comment_author_url, comment_date, post_title, comment_type
				FROM $wpdb->comments LEFT JOIN $wpdb->posts ON $wpdb->posts.ID=$wpdb->comments.comment_post_ID
				WHERE post_status IN ('publish','static')";

	switch($type) {
		case 'all':
			// add nothing
			break;
		case 'comment_only':
			//
			$request .= "AND $wpdb->comments.comment_type='' ";
			break;
		case 'trackback_only':
			$request .= "AND ( $wpdb->comments.comment_type='trackback' OR $wpdb->comments.comment_type='pingback' ) ";
			break;
	 default:
 		//
			break;

	}

	if (!$show_pass_post) $request .= "AND post_password ='' ";

	$request .= "AND comment_approved = '1' ORDER BY comment_ID DESC LIMIT $no_comments";

	$comments = $wpdb->get_results($request);
    $output = '';
	if ($comments) {
    	foreach ($comments as $comment) {

			// Permalink to post/comment
			$loop_res['permalink'] = get_permalink($comment->ID). '#comment-' . $comment->comment_ID;

			// Title of the post
			$loop_res['post_title'] = stripslashes($comment->post_title);
			$loop_res['post_title'] = wordwrap($loop_res['post_title'], $wordwrap_length, ' ' , 1);

			if (strlen($loop_res['post_title']) >= $title_length) {
				$loop_res['post_title'] = substr($loop_res['post_title'], 0, $title_length) . '&#8230;';
			}

			// Author's name only
        	$loop_res['author_name'] = stripslashes($comment->comment_author);
			$loop_res['author_name'] = wordwrap($loop_res['author_name'], $wordwrap_length, ' ' , 1);

			if ($loop_res['author_name'] == '') $loop_res['author_name'] = $mwlang_anonymous;
			if (strlen($loop_res['author_name']) >= $author_length) {
				$loop_res['author_name'] = substr($loop_res['author_name'], 0, $author_length) . '&#8230;';
			}

			// Full author (link, name)
			$author_url = $comment->comment_author_url;
			if (empty($author_url)) {
				$loop_res['author_full'] = $loop_res['author_name'];
			} else {
				$loop_res['author_full'] = '<a href="' . $author_url . '" title="' . $mwlang_authorurl_title_before . $loop_res['author_name'] . $mwlang_authorurl_title_after . '">' . $loop_res['author_name'] . '</a>';
			}


			// Comment excerpt
			$comment_excerpt = strip_tags($comment->comment_content);
			$comment_excerpt = stripslashes($comment_excerpt);
			if (strlen($comment_excerpt) >= $comment_length) {
				$comment_excerpt = substr($comment_excerpt, 0, $comment_length) . '...';
			}

			// Comment type
			if ( $comment->comment_type == 'pingback' ) {
				$loop_res['comment_type'] = $type_text_pingback;
			} elseif ( $comment->comment_type == 'trackback' ) {
				$loop_res['comment_type'] = $type_text_trackback;
			} else {
				$loop_res['comment_type'] = $type_text_comment;
			}

			// Date of comment
			$loop_res['comment_date'] = mysql2date($date_format, $comment->comment_date);

			// Output element
			$element_loop = str_replace('%permalink%', $loop_res['permalink'], $format);
			$element_loop = str_replace('%title%', $loop_res['post_title'], $element_loop);
			$element_loop = str_replace('%author_name%', $loop_res['author_name'], $element_loop);
			$element_loop = str_replace('%author_full%', $loop_res['author_full'], $element_loop);
			$element_loop = str_replace('%date%', $loop_res['comment_date'], $element_loop);
			$element_loop = str_replace('%type%', $loop_res['comment_type'], $element_loop);
			$element_loop = str_replace('%excerpt%', $comment_excerpt, $element_loop);


			$output .= $element_loop . "\n";


		} //foreach

		$output = convert_smilies($output);

	} else {
		$output .= $none_found;
    }

    echo $output;
}


function themefunction_content($max_char,$more_link_text='(далее...)',$stripteaser=0,$more_file='') {
	$content = get_the_content($more_link_text, $stripteaser, $more_file);
	$content = apply_filters('the_content', $content);
	$content = str_replace(']]>', ']]&gt;', $content);
	$content = strip_tags($content);

	$space = strpos($content," ",$max_char);
	if (strlen($_GET['p']) > 0) {
		echo "<p>";
		echo $content;
		echo "&nbsp;<a href='";
		the_permalink();
		echo "'>"."Далее &rarr;</a>";
		echo "</p>";
	} else if ((strlen($content)>$max_char) && $space) {
		$content = substr($content,0,$space);
		$content = $content;
		echo "<p>";
		echo $content;
		echo "...";
		echo "&nbsp;<a href='";
		the_permalink();
		echo "'>".$more_link_text."</a>";
		echo "</p>";
	} else {
		echo "<p>";
		echo $content;
		echo "&nbsp;<a href='";
		the_permalink();
		echo "'>"."Далее &rarr;</a>";
		echo "</p>";
	}
}

function themefunction_comments($comment, $args, $depth) {
	$GLOBALS['comment'] = $comment; ?>
	<li <?php comment_class(); ?> id="comment-<?php comment_ID() ?>">
		<div class="comment" id="div-comment-<?php comment_ID(); ?>">
			<div class="comment-author vcard">
				<?php echo get_avatar($comment,$size='32',$default='<path_to_url>' ); ?>
				<?php printf(__('<cite class="fn">%s</cite> <span class="says">пишет:</span>'), get_comment_author_link()) ?>
				<div class="comment-meta commentmetadata">
					<a href="<?php echo htmlspecialchars( get_comment_link( $comment->comment_ID ) ) ?>"><?php printf(__('%1$s в %2$s'), get_comment_date(),  get_comment_time()) ?></a> <?php edit_comment_link(__('(править)'),'  ','') ?>
				</div>
			</div>
			<?php if ($comment->comment_approved == '0') : ?>
			<em><?php _e('Спасибо! Ваш комментарий ожидает проверки.') ?></em>
			<br />
			<?php endif; ?>

			<?php comment_text() ?>

			<div class="reply">
				<?php comment_reply_link(array_merge( $args, array('add_below' => 'div-comment', 'depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
			</div>
		</div>
	<?php
}
?>
